Bläddra i källkod

rebar release

erylee 13 år sedan
förälder
incheckning
50baba2cf6
8 ändrade filer med 352 tillägg och 196 borttagningar
  1. 1 0
      .gitignore
  2. 2 1
      rebar.config
  3. 1 1
      rel/files/app.config
  4. 192 170
      rel/files/emqtt
  5. 38 17
      rel/files/emqtt_ctl
  6. 77 1
      rel/files/nodetool
  7. 12 6
      rel/reltool.config
  8. 29 0
      rel/vars.config

+ 1 - 0
.gitignore

@@ -2,4 +2,5 @@ lib
 ebin
 var
 *.log
+rel/emqtt
 

+ 2 - 1
rebar.config

@@ -11,5 +11,6 @@
 {deps_dir, ["lib"]}.
 
 {deps, [
-	{lager, ".*", {git, "git://github.com/basho/lager.git", {branch, "master"}}}
+	{lager, ".*", {git, "git://github.com/basho/lager.git", {branch, "master"}}},
+	{folsom, ".*", {git, "git://github.com/boundary/folsom.git", {branch, "master"}}}
 ]}.

+ 1 - 1
rel/files/app.config

@@ -8,7 +8,7 @@
 	{sasl_error_logger, {file, "log/emqtt_sasl.log"}}
  ]},
  {mnesia, [
-	{dir, "var/mnesia"}
+	{dir, "var/data"}
  ]},
  {lager, [
 	{error_logger_redirect, false},

+ 192 - 170
rel/files/emqtt

@@ -2,147 +2,198 @@
 # -*- tab-width:4;indent-tabs-mode:nil -*-
 # ex: ts=4 sw=4 et
 
-RUNNER_SCRIPT_DIR=$(cd ${0%/*} && pwd)
+# /bin/sh on Solaris is not a POSIX compatible shell, but /usr/bin/ksh is.
+if [ `uname -s` = 'SunOS' -a "${POSIX_SHELL}" != "true" ]; then
+    POSIX_SHELL="true"
+    export POSIX_SHELL
+    # To support 'whoami' add /usr/ucb to path
+    PATH=/usr/ucb:$PATH
+    export PATH
+    exec /usr/bin/ksh $0 "$@"
+fi
+unset POSIX_SHELL # clear it so if we invoke other scripts, they run as ksh as well
 
-CALLER_DIR=$PWD
+RUNNER_SCRIPT_DIR={{runner_script_dir}}
+RUNNER_SCRIPT=${0##*/}
 
-RUNNER_BASE_DIR=${RUNNER_SCRIPT_DIR%/*}
-RUNNER_ETC_DIR=$RUNNER_BASE_DIR/etc
+RUNNER_BASE_DIR={{runner_base_dir}}
+RUNNER_ETC_DIR={{runner_etc_dir}}
+RUNNER_LIB_DIR={{platform_lib_dir}}
+RUNNER_LOG_DIR={{runner_log_dir}}
 # Note the trailing slash on $PIPE_DIR/
-PIPE_DIR=/tmp/$RUNNER_BASE_DIR/
-RUNNER_USER=
+PIPE_DIR={{pipe_dir}}
+RUNNER_USER={{runner_user}}
+PLATFORM_DATA_DIR={{platform_data_dir}}
+SSL_DIST_CONFIG=$PLATFORM_DATA_DIR/ssl_distribution.args_file
+RIAK_VERSION="git"
+
+WHOAMI=$(whoami)
 
 # Make sure this script is running as the appropriate user
-if [ ! -z "$RUNNER_USER" ] && [ `whoami` != "$RUNNER_USER" ]; then
-    exec sudo -u $RUNNER_USER -i $0 $@
+if ([ "$RUNNER_USER" ] && [ "x$WHOAMI" != "x$RUNNER_USER" ]); then
+    type sudo > /dev/null 2>&1
+    if [ $? -ne 0 ]; then
+        echo "sudo doesn't appear to be installed and your EUID isn't $RUNNER_USER" 1>&2
+        exit 1
+    fi
+    echo "Attempting to restart script through sudo -H -u $RUNNER_USER" >&2
+    exec sudo -H -u $RUNNER_USER -i $RUNNER_SCRIPT_DIR/$RUNNER_SCRIPT $@
 fi
 
-# Identify the script name
-SCRIPT=`basename $0`
-
-# Parse out release and erts info
-START_ERL=`cat $RUNNER_BASE_DIR/releases/start_erl.data`
-ERTS_VSN=${START_ERL% *}
-APP_VSN=${START_ERL#* }
-
-# Use $CWD/vm.args if exists, otherwise releases/APP_VSN/vm.args, or else etc/vm.args
-if [ -e "$CALLER_DIR/vm.args" ]; then
-    VMARGS_PATH=$CALLER_DIR/vm.args
-    USE_DIR=$CALLER_DIR
-else
-    USE_DIR=$RUNNER_BASE_DIR
-    if [ -e "$RUNNER_BASE_DIR/releases/$APP_VSN/vm.args" ]; then
-        VMARGS_PATH="$RUNNER_BASE_DIR/releases/$APP_VSN/vm.args"
-    else
-        VMARGS_PATH="$RUNNER_ETC_DIR/vm.args"
-    fi
+# Warn the user if ulimit -n is less than 1024
+ULIMIT_F=`ulimit -n`
+if [ "$ULIMIT_F" -lt 1024 ]; then
+    echo "!!!!"
+    echo "!!!! WARNING: ulimit -n is ${ULIMIT_F}; 1024 is the recommended minimum."
+    echo "!!!!"
 fi
 
-RUNNER_LOG_DIR=$USE_DIR/log
+# Make sure CWD is set to runner base dir
+cd $RUNNER_BASE_DIR
+
 # Make sure log directory exists
 mkdir -p $RUNNER_LOG_DIR
 
-# Use releases/VSN/sys.config if it exists otherwise use etc/app.config
-if [ -e "$USE_DIR/sys.config" ]; then
-    CONFIG_PATH="$USE_DIR/sys.config"
-else
-    if [ -e "$RUNNER_BASE_DIR/releases/$APP_VSN/sys.config" ]; then
-        CONFIG_PATH="$RUNNER_BASE_DIR/releases/$APP_VSN/sys.config"
-    else
-        CONFIG_PATH="$RUNNER_ETC_DIR/app.config"
-    fi
+# Make sure the data directory exists
+mkdir -p $PLATFORM_DATA_DIR
+
+# Warn the user if they don't have write permissions on the log dir
+if [ ! -w $RUNNER_LOG_DIR ]; then
+    echo "!!!!"
+    echo "!!!! WARNING: $RUNNER_LOG_DIR not writable; logs and crash dumps unavailable."
+    echo "!!!!"
 fi
 
 # Extract the target node name from node.args
-NAME_ARG=`egrep '^-s?name' $VMARGS_PATH`
+NAME_ARG=`egrep '^\-s?name' $RUNNER_ETC_DIR/vm.args`
 if [ -z "$NAME_ARG" ]; then
     echo "vm.args needs to have either -name or -sname parameter."
     exit 1
 fi
 
-# Extract the name type and name from the NAME_ARG for REMSH
-REMSH_TYPE=`echo $NAME_ARG | awk '{print $1}'`
-REMSH_NAME=`echo $NAME_ARG | awk '{print $2}'`
-
-# Note the `date +%s`, used to allow multiple remsh to the same node transparently
-REMSH_NAME_ARG="$REMSH_TYPE remsh`date +%s`@`echo $REMSH_NAME | awk -F@ '{print $2}'`"
-REMSH_REMSH_ARG="-remsh $REMSH_NAME"
-
 # Extract the target cookie
-COOKIE_ARG=`grep '^-setcookie' $VMARGS_PATH`
+COOKIE_ARG=`grep '^\-setcookie' $RUNNER_ETC_DIR/vm.args`
 if [ -z "$COOKIE_ARG" ]; then
     echo "vm.args needs to have a -setcookie parameter."
     exit 1
 fi
 
-# Make sure CWD is set to the right dir
-cd $USE_DIR
-
-# Make sure log directory exists
-mkdir -p $USE_DIR/log
+# Identify the script name
+SCRIPT=`basename $0`
 
+# Parse out release and erts info
+START_ERL=`cat $RUNNER_BASE_DIR/releases/start_erl.data`
+ERTS_VSN=${START_ERL% *}
+APP_VSN=${START_ERL#* }
 
 # Add ERTS bin dir to our path
 ERTS_PATH=$RUNNER_BASE_DIR/erts-$ERTS_VSN/bin
 
 # Setup command to control the node
 NODETOOL="$ERTS_PATH/escript $ERTS_PATH/nodetool $NAME_ARG $COOKIE_ARG"
+NODETOOL_LITE="$ERTS_PATH/escript $ERTS_PATH/nodetool"
+
+# Common functions
+
+# Ping node without allowing nodetool to take stdin
+ping_node() {
+    $NODETOOL ping < /dev/null
+}
+
+# Set the PID global variable, return 1 on error
+get_pid() {
+    PID=`$NODETOOL getpid < /dev/null`
+    ES=$?
+    if [ "$ES" -ne 0 ]; then
+        echo "Node is not running!"
+        return 1
+    fi
+
+    # don't allow empty or init pid's
+    if [ -z $PID ] || [ "$PID" -le 1 ]; then
+        return 1
+    fi
 
-# Setup remote shell command to control node
-REMSH="$ERTS_PATH/erl $REMSH_NAME_ARG $REMSH_REMSH_ARG $COOKIE_ARG"
+    return 0
+}
+
+
+# Scrape out SSL distribution config info from vm.args into $SSL_DIST_CONFIG
+rm -f $SSL_DIST_CONFIG
+sed -n '/Begin SSL distribution items/,/End SSL distribution items/p' \
+    $RUNNER_ETC_DIR/vm.args > $SSL_DIST_CONFIG
 
 # Check the first argument for instructions
 case "$1" in
-    start|start_boot)
+    start)
         # Make sure there is not already a node running
-        RES=`$NODETOOL ping`
+        RES=`ping_node`
         if [ "$RES" = "pong" ]; then
             echo "Node is already running!"
             exit 1
         fi
-        case "$1" in
-            start)
-                shift
-                START_OPTION="console"
-                HEART_OPTION="start"
-                ;;
-            start_boot)
-                shift
-                START_OPTION="console_boot"
-                HEART_OPTION="start_boot"
-                ;;
-        esac
-        RUN_PARAM=$(printf "\'%s\' " "$@")
-        HEART_COMMAND="$RUNNER_BASE_DIR/bin/$SCRIPT $HEART_OPTION $RUN_PARAM"
+        # Sanity check the app.config file
+        RES=`$NODETOOL_LITE chkconfig $RUNNER_ETC_DIR/app.config`
+        if [ $? != 0 ]; then
+            echo "Error reading $RUNNER_ETC_DIR/app.config"
+            echo $RES
+            exit 1
+        fi
+        HEART_COMMAND="$RUNNER_SCRIPT_DIR/$SCRIPT start"
         export HEART_COMMAND
         mkdir -p $PIPE_DIR
-        $ERTS_PATH/run_erl -daemon $PIPE_DIR $RUNNER_LOG_DIR "exec $RUNNER_BASE_DIR/bin/$SCRIPT $START_OPTION $RUN_PARAM" 2>&1
+        $ERTS_PATH/run_erl -daemon $PIPE_DIR $RUNNER_LOG_DIR \
+            "exec $RUNNER_SCRIPT_DIR/$SCRIPT console" 2>&1
+
+        # Wait for the node to come up. We can't just ping it because
+        # distributed erlang comes up for a second before emqtt crashes
+        # (eg. in the case of an unwriteable disk). Once the node comes
+        # up we check for the node watcher process. If that's running
+        # then we assume things are good enough. This will at least let
+        # the user know when emqtt is crashing right after startup.
+        WAIT=${WAIT_FOR_ERLANG:-15}
+        while [ $WAIT -gt 0 ]; do
+            WAIT=`expr $WAIT - 1`
+            sleep 1
+            RES=`ping_node`
+            if [ "$?" -ne 0 ]; then
+                continue
+            fi
+		#TODO: echo start successfully?
+            exit 0
+        done
+        echo "emqtt failed to start within ${WAIT_FOR_ERLANG:-15} seconds,"
+        echo "see the output of 'emqtt console' for more information."
+        echo "If you want to wait longer, set the environment variable"
+        echo "WAIT_FOR_ERLANG to the number of seconds to wait."
+        exit 1
         ;;
 
     stop)
-        # Wait for the node to completely stop...
-        case `uname -s` in
-            Linux|Darwin|FreeBSD|DragonFly|NetBSD|OpenBSD)
-                # PID COMMAND
-                PID=`ps ax -o pid= -o command=|\
-                    grep "$RUNNER_BASE_DIR/.*/[b]eam"|awk '{print $1}'`
-                ;;
-            SunOS)
-                # PID COMMAND
-                PID=`ps -ef -o pid= -o args=|\
-                    grep "$RUNNER_BASE_DIR/.*/[b]eam"|awk '{print $1}'`
-                ;;
-            CYGWIN*)
-                # UID PID PPID TTY STIME COMMAND
-                PID=`ps -efW|grep "$RUNNER_BASE_DIR/.*/[b]eam"|awk '{print $2}'`
-                ;;
+        UNAME_S=`uname -s`
+        case $UNAME_S in
+            Darwin)
+                # Make sure we explicitly set this because iTerm.app doesn't for
+                # some reason.
+                COMMAND_MODE=unix2003
         esac
+
+        # Get the PID from nodetool
+        get_pid
+        GPR=$?
+        if [ "$GPR" -ne 0 ] || [ -z $PID ]; then
+            exit $GPR
+        fi
+
+        # Tell nodetool to initiate a stop
         $NODETOOL stop
         ES=$?
         if [ "$ES" -ne 0 ]; then
             exit $ES
         fi
-        while `kill -0 $PID 2>/dev/null`;
+
+        # Wait for the node to completely stop...
+        while `kill -s 0 $PID 2>/dev/null`;
         do
             sleep 1
         done
@@ -168,7 +219,7 @@ case "$1" in
 
     ping)
         ## See if the VM is alive
-        $NODETOOL ping
+        ping_node
         ES=$?
         if [ "$ES" -ne 0 ]; then
             exit $ES
@@ -176,115 +227,86 @@ case "$1" in
         ;;
 
     attach)
-        # Make sure a node IS running
-        RES=`$NODETOOL ping`
-        ES=$?
-        if [ "$ES" -ne 0 ]; then
-            echo "Node is not running!"
-            exit $ES
+        if [ "$2" = "-f" ]; then
+          echo "Forcing connection..."
+        else
+          # Make sure a node is running
+          RES=`ping_node`
+          ES=$?
+          if [ "$ES" -ne 0 ]; then
+              echo "Node is not running!"
+              exit $ES
+          fi
         fi
 
         shift
         exec $ERTS_PATH/to_erl $PIPE_DIR
         ;;
 
-    remote_console)
-        # Make sure a node IS running
-        RES=`$NODETOOL ping`
-        ES=$?
-        if [ "$ES" -ne 0 ]; then
-            echo "Node is not running!"
-            exit $ES
-        fi
-
-        shift
-        exec $REMSH
-        ;;
-
-    upgrade)
-        if [ -z "$2" ]; then
-            echo "Missing upgrade package argument"
-            echo "Usage: $SCRIPT upgrade {package base name}"
-            echo "NOTE {package base name} MUST NOT include the .tar.gz suffix"
+    console)
+        RES=`ping_node`
+        if [ "$RES" = "pong" ]; then
+            echo "Node is already running - use '$SCRIPT attach' instead"
             exit 1
         fi
-
-        # Make sure a node IS running
-        RES=`$NODETOOL ping`
-        ES=$?
-        if [ "$ES" -ne 0 ]; then
-            echo "Node is not running!"
-            exit $ES
+        # Sanity check the app.config file
+        RES=`$NODETOOL_LITE chkconfig $RUNNER_ETC_DIR/app.config`
+        if [ $? != 0 ]; then
+            echo "Error reading $RUNNER_ETC_DIR/app.config"
+            echo $RES
+            exit 1
         fi
-
-        node_name=`echo $NAME_ARG | awk '{print $2}'`
-        erlang_cookie=`echo $COOKIE_ARG | awk '{print $2}'`
-
-        $ERTS_PATH/escript $RUNNER_BASE_DIR/bin/install_upgrade.escript $node_name $erlang_cookie $2
-        ;;
-
-    console|console_clean|console_boot)
-        # .boot file typically just $SCRIPT (ie, the app name)
-        # however, for debugging, sometimes start_clean.boot is useful.
-        # For e.g. 'setup', one may even want to name another boot script.
-        case "$1" in
-            console)        BOOTFILE=$SCRIPT ;;
-            console_clean)  BOOTFILE=start_clean ;;
-            console_boot)
-                shift
-                BOOTFILE="$1"
-                shift
-                ;;
-        esac
         # Setup beam-required vars
         ROOTDIR=$RUNNER_BASE_DIR
         BINDIR=$ROOTDIR/erts-$ERTS_VSN/bin
         EMU=beam
-        PROGNAME=`echo $0 | sed 's/.*\\///'`
-        CMD="$BINDIR/erlexec -boot $RUNNER_BASE_DIR/releases/$APP_VSN/$BOOTFILE -mode embedded -config $CONFIG_PATH -args_file $VMARGS_PATH"
+        PROGNAME=`echo $0 | sed 's/.*\///'`
+        CMD="$BINDIR/erlexec -boot $RUNNER_BASE_DIR/releases/$APP_VSN/$SCRIPT \
+            -embedded -config $RUNNER_ETC_DIR/app.config \
+            -pa $RUNNER_LIB_DIR/basho-patches \
+            -args_file $RUNNER_ETC_DIR/vm.args -- ${1+"$@"}"
         export EMU
         export ROOTDIR
         export BINDIR
         export PROGNAME
 
         # Dump environment info for logging purposes
-        echo "Exec: $CMD" -- ${1+"$@"}
+        echo "Exec: $CMD"
         echo "Root: $ROOTDIR"
 
         # Log the startup
         logger -t "$SCRIPT[$$]" "Starting up"
 
         # Start the VM
-        exec $CMD -- ${1+"$@"}
+        exec $CMD
         ;;
-
-    foreground)
-        # start up the release in the foreground for use by runit
-        # or other supervision services
-
-        BOOTFILE=$SCRIPT
-        FOREGROUNDOPTIONS="-noinput +Bd"
-
-        # Setup beam-required vars
-        ROOTDIR=$RUNNER_BASE_DIR
-        BINDIR=$ROOTDIR/erts-$ERTS_VSN/bin
-        EMU=beam
-        PROGNAME=`echo $0 | sed 's/.*\///'`
-        CMD="$BINDIR/erlexec $FOREGROUNDOPTIONS -boot $RUNNER_BASE_DIR/releases/$APP_VSN/$BOOTFILE -config $CONFIG_PATH -args_file $VMARGS_PATH"
-        export EMU
-        export ROOTDIR
-        export BINDIR
-        export PROGNAME
-
-        # Dump environment info for logging purposes
-        echo "Exec: $CMD" -- ${1+"$@"}
-        echo "Root: $ROOTDIR"
-
-        # Start the VM
-        exec $CMD -- ${1+"$@"}
+    chkconfig)
+        RES=`$NODETOOL_LITE chkconfig $RUNNER_ETC_DIR/app.config`
+        if [ $? != 0 ]; then
+            echo "Error reading $RUNNER_ETC_DIR/app.config"
+            echo $RES
+            exit 1
+        fi
+        echo "config is OK"
+        ;;
+    escript)
+        shift
+        $ERTS_PATH/escript "$@"
+        ;;
+    version)
+        echo $RIAK_VERSION
+        ;;
+    getpid)
+        # Get the PID from nodetool
+        get_pid
+        ES=$?
+        if [ "$ES" -ne 0 ] || [ -z $PID ]; then
+            exit $ES
+        fi
+        echo $PID
         ;;
     *)
-        echo "Usage: $SCRIPT {start|start_boot <file>|foreground|stop|restart|reboot|ping|console|console_clean|console_boot <file>|attach|remote_console|upgrade}"
+        echo "Usage: $SCRIPT {start|stop|restart|reboot|ping|console|attach|chkconfig|escript|version|getpid}"
         exit 1
         ;;
 esac

+ 38 - 17
rel/files/emqtt_ctl

@@ -1,22 +1,45 @@
-#!/bin/bash
+#!/bin/sh
+
+# /bin/sh on Solaris is not a POSIX compatible shell, but /usr/bin/ksh is.
+if [ `uname -s` = 'SunOS' -a "${POSIX_SHELL}" != "true" ]; then
+    POSIX_SHELL="true"
+    export POSIX_SHELL
+    # To support 'whoami' add /usr/ucb to path
+    PATH=/usr/ucb:$PATH
+    export PATH
+    exec /usr/bin/ksh $0 "$@"
+fi
+unset POSIX_SHELL # clear it so if we invoke other scripts, they run as ksh as well
+
+RUNNER_SCRIPT_DIR={{runner_script_dir}}
+RUNNER_SCRIPT=${0##*/}
 
-RUNNER_SCRIPT_DIR=$(cd ${0%/*} && pwd)
+RUNNER_BASE_DIR={{runner_base_dir}}
+RUNNER_ETC_DIR={{runner_etc_dir}}
+RUNNER_LIB_DIR={{platform_lib_dir}}
+RUNNER_LOG_DIR={{runner_log_dir}}
+RUNNER_USER={{runner_user}}
 
-RUNNER_BASE_DIR=${RUNNER_SCRIPT_DIR%/*}
-RUNNER_ETC_DIR=$RUNNER_BASE_DIR/etc
-RUNNER_BIN_DIR=$RUNNER_BASE_DIR/bin
-RUNNER_LOG_DIR=$RUNNER_BASE_DIR/log
+WHOAMI=$(whoami)
 
-RUNNER_EBIN_DIR=$RUNNER_BASE_DIR/ebin
-RUNNER_USER=
+# Make sure this script is running as the appropriate user
+if ([ "$RUNNER_USER" ] && [ "x$WHOAMI" != "x$RUNNER_USER" ]); then
+    type sudo > /dev/null 2>&1
+    if [ $? -ne 0 ]; then
+        echo "sudo doesn't appear to be installed and your EUID isn't $RUNNER_USER" 1>&2
+        exit 1
+    fi
+    echo "Attempting to restart script through sudo -H -u $RUNNER_USER" >&2
+    exec sudo -H -u $RUNNER_USER -i $RUNNER_SCRIPT_DIR/$RUNNER_SCRIPT $@
+fi
 
 # Make sure CWD is set to runner base dir
 cd $RUNNER_BASE_DIR
 
 # Extract the target node name from node.args
-NAME_ARG=`grep '\-[s]*name' $RUNNER_ETC_DIR/emqtt.args`
+NAME_ARG=`egrep "^ *-s?name" $RUNNER_ETC_DIR/vm.args`
 if [ -z "$NAME_ARG" ]; then
-    echo "emqtt.args needs to have either -name or -sname parameter."
+    echo "vm.args needs to have either -name or -sname parameter."
     exit 1
 fi
 
@@ -36,9 +59,9 @@ else
 fi
 
 # Extract the target cookie
-COOKIE_ARG=`grep '\-setcookie' $RUNNER_ETC_DIR/emqtt.args`
+COOKIE_ARG=`grep '\-setcookie' $RUNNER_ETC_DIR/vm.args`
 if [ -z "$COOKIE_ARG" ]; then
-    echo "emqtt.args needs to have a -setcookie parameter."
+    echo "vm.args needs to have a -setcookie parameter."
     exit 1
 fi
 
@@ -46,16 +69,15 @@ fi
 SCRIPT=`basename $0`
 
 # Parse out release and erts info
-ERLANG_BASE_DIR=/usr/local/lib/erlang
-START_ERL=`cat $ERLANG_BASE_DIR/releases/start_erl.data`
+START_ERL=`cat $RUNNER_BASE_DIR/releases/start_erl.data`
 ERTS_VSN=${START_ERL% *}
 APP_VSN=${START_ERL#* }
 
 # Add ERTS bin dir to our path
-ERTS_PATH=$ERLANG_BASE_DIR/erts-$ERTS_VSN/bin
+ERTS_PATH=$RUNNER_BASE_DIR/erts-$ERTS_VSN/bin
 
 # Setup command to control the node
-NODETOOL="$ERTS_PATH/escript $RUNNER_BIN_DIR/nodetool $NAME_ARG $COOKIE_ARG"
+NODETOOL="$ERTS_PATH/escript $ERTS_PATH/nodetool $NAME_ARG $COOKIE_ARG"
 
 # Check the first argument for instructions
 case "$1" in
@@ -65,7 +87,6 @@ case "$1" in
             exit 1
         fi
 
-        # Make sure the local node IS running
         RES=`$NODETOOL ping`
         if [ "$RES" != "pong" ]; then
             echo "Node is not running!"

+ 77 - 1
rel/files/nodetool

@@ -1,3 +1,5 @@
+#!/usr/bin/env escript
+
 %% -*- mode: erlang;erlang-indent-level: 4;indent-tabs-mode: nil -*-
 %% ex: ft=erlang ts=4 sw=4 et
 %% -------------------------------------------------------------------
@@ -5,22 +7,60 @@
 %% nodetool: Helper Script for interacting with live nodes
 %%
 %% -------------------------------------------------------------------
+-mode(compile).
 
 main(Args) ->
     ok = start_epmd(),
     %% Extract the args
     {RestArgs, TargetNode} = process_args(Args, [], undefined),
 
+    %% process_args() has side-effects (e.g. when processing "-name"),
+    %% so take care of app-starting business first.
+    [application:start(App) || App <- [crypto, public_key, ssl]],
+
+    %% any commands that don't need a running node
+    case RestArgs of
+        ["chkconfig", File] ->
+            case file:consult(File) of
+                {ok, Terms} ->
+                    case validate(Terms) of
+                        ok ->
+                            io:format("ok\n"),
+                            halt(0);
+                        {error, Problems} ->
+                            lists:foreach(fun print_issue/1, Problems),
+                            %% halt(1) if any problems were errors
+                            halt(case [x || {error, _} <- Problems] of
+                                     [] -> 0;
+                                     _  -> 1
+                                 end)
+                    end;
+                {error, {Line, Mod, Term}} ->
+                    io:format(standard_error, ["Error on line ", file:format_error({Line, Mod, Term}), "\n"], []),
+                    halt(1);
+                {error, R} ->
+                    io:format(standard_error, ["Error reading config file: ", file:format_error(R), "\n"], []),
+                    halt(1)
+            end;
+        _ ->
+            ok
+    end,
+
     %% See if the node is currently running  -- if it's not, we'll bail
     case {net_kernel:hidden_connect_node(TargetNode), net_adm:ping(TargetNode)} of
         {true, pong} ->
             ok;
+        {false,pong} ->
+            io:format("Failed to connect to node ~p .\n", [TargetNode]),
+            halt(1);
         {_, pang} ->
             io:format("Node ~p not responding to pings.\n", [TargetNode]),
             halt(1)
     end,
 
     case RestArgs of
+        ["getpid"] ->
+            io:format("~p\n", [list_to_integer(rpc:call(TargetNode, os, getpid, []))]);
         ["ping"] ->
             %% If we got this far, the node already responsed to a ping, so just dump
             %% a "pong"
@@ -42,6 +82,16 @@ main(Args) ->
                 _ ->
                     halt(1)
             end;
+        ["rpc_infinity", Module, Function | RpcArgs] ->
+            case rpc:call(TargetNode, list_to_atom(Module), list_to_atom(Function), [RpcArgs], infinity) of
+                ok ->
+                    ok;
+                {badrpc, Reason} ->
+                    io:format("RPC to ~p failed: ~p\n", [TargetNode, Reason]),
+                    halt(1);
+                _ ->
+                    halt(1)
+            end;
         ["rpcterms", Module, Function, ArgsAsString] ->
             case rpc:call(TargetNode, list_to_atom(Module), list_to_atom(Function),
                           consult(ArgsAsString), 60000) of
@@ -53,10 +103,11 @@ main(Args) ->
             end;
         Other ->
             io:format("Other: ~p\n", [Other]),
-            io:format("Usage: nodetool {ping|stop|restart|reboot}\n")
+            io:format("Usage: nodetool {chkconfig|getpid|ping|stop|restart|reboot|rpc|rpc_infinity|rpcterms}\n")
     end,
     net_kernel:stop().
 
+
 process_args([], Acc, TargetNode) ->
     {lists:reverse(Acc), TargetNode};
 process_args(["-setcookie", Cookie | Rest], Acc, TargetNode) ->
@@ -136,3 +187,28 @@ consult(Cont, Str, Acc) ->
         {more, Cont1} ->
             consult(Cont1, eof, Acc)
     end.
+
+
+%%
+%% Validation functions for checking the app.config
+%%
+validate([Terms]) ->
+    Results = [ValidateFun(Terms) || ValidateFun <- get_validation_funs()],
+    Failures = [Res || Res <- Results, Res /= true],
+    case Failures of
+        [] ->
+            ok;
+        _ ->
+            {error, Failures}
+    end.
+
+%% Some initial and basic checks for the app.config file
+get_validation_funs() ->
+    [ ].
+
+print_issue({warning, Warning}) ->
+    io:format(standard_error, "Warning in app.config: ~s~n", [Warning]);
+print_issue({error, Error}) ->
+    io:format(standard_error, "Error in app.config: ~s~n", [Error]).
+
+

+ 12 - 6
rel/reltool.config

@@ -9,6 +9,8 @@
          sasl,
          mnesia,
 	 lager,
+	 compiler,
+	 %{folsom, load},
          emqtt
         ]},
        {rel, "start_clean", "",
@@ -28,23 +30,27 @@
        {app, stdlib, [{incl_cond, include}]},
        {app, sasl, [{incl_cond, include}]},
        {app, mnesia, [{incl_cond, include}]},
+       {app, compiler, [{incl_cond, include}]},
        {app, lager, [{incl_cond, include}]},
+       %{app, folsom, [{incl_cond, include}]},
        {app, emqtt, [{mod_cond, app}, {incl_cond, include}]}
       ]}.
 
 {target_dir, "emqtt"}.
 
+{overlay_vars, "vars.config"}.
+
 {overlay, [
            {mkdir, "log/"},
            {mkdir, "etc/"},
            {mkdir, "var/data/"},
            {copy, "files/erl", "\{\{erts_vsn\}\}/bin/erl"},
-           {copy, "files/nodetool", "\{\{erts_vsn\}\}/bin/nodetool"},
-           {copy, "files/emqtt", "bin/emqtt"},
-           {copy, "files/emqtt_ctl", "bin/emqtt_ctl"},
-           {copy, "files/emqtt.cmd", "bin/emqtt.cmd"},
+           {template, "files/nodetool", "\{\{erts_vsn\}\}/bin/nodetool"},
+           {template, "files/emqtt", "bin/emqtt"},
+           {template, "files/emqtt_ctl", "bin/emqtt_ctl"},
+           {template, "files/emqtt.cmd", "bin/emqtt.cmd"},
            {copy, "files/start_erl.cmd", "bin/start_erl.cmd"},
            {copy, "files/install_upgrade.escript", "bin/install_upgrade.escript"},
-           {copy, "files/app.config", "etc/app.config"},
-           {copy, "files/vm.args", "etc/vm.args"}
+           {template, "files/app.config", "etc/app.config"},
+           {template, "files/vm.args", "etc/vm.args"}
           ]}.

+ 29 - 0
rel/vars.config

@@ -0,0 +1,29 @@
+%% -*- mode: erlang;erlang-indent-level: 4;indent-tabs-mode: nil -*-
+%% ex: ft=erlang ts=4 sw=4 et
+
+%% Platform-specific installation paths
+{platform_bin_dir,  "./bin"}.
+{platform_data_dir, "./var/data"}.
+{platform_etc_dir,  "./etc"}.
+{platform_lib_dir,  "./lib"}.
+{platform_log_dir,  "./log"}.
+
+%%
+%% etc/app.config
+%%
+
+
+%%
+%% etc/vm.args
+%% 
+
+%%
+%% bin/emqtt
+%% 
+{runner_script_dir,  "$(cd ${0%/*} && pwd)"}.
+{runner_base_dir,    "${RUNNER_SCRIPT_DIR%/*}"}.
+{runner_etc_dir,     "$RUNNER_BASE_DIR/etc"}.
+{runner_log_dir,     "$RUNNER_BASE_DIR/log"}.
+{pipe_dir,           "/tmp/$RUNNER_BASE_DIR/"}.
+{runner_user,        ""}.
+